/**************************************************************************
*   Copyright (C) 2009 by Ian Reinhart Geiser                             *
*   geiseri@kde.org                                                       *
*                                                                         *
*   This program is free software; you can redistribute it and/or modify  *
*   it under the terms of the GNU General Public License as published by  *
*   the Free Software Foundation; either version 2 of the License, or     *
*   (at your option) any later version.                                   *
*                                                                         *
*   This program is distributed in the hope that it will be useful,       *
*   but WITHOUT ANY WARRANTY; without even the implied warranty of        *
*   MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the         *
*   GNU General Public License for more details.                          *
*                                                                         *
*   You should have received a copy of the GNU General Public License     *
*   along with this program; if not, write to the                         *
*   Free Software Foundation, Inc.,                                       *
*   59 Temple Place - Suite 330, Boston, MA  02111-1307, USA.             *
***************************************************************************/

#ifndef SYSTEMTRAY_H
#define SYSTEMTRAY_H

#include <QFrame>
#include <QList>

class QX11EmbedWidget;
class QHBoxLayout;

class SystemTray : public QFrame
{
    Q_OBJECT
public:
    SystemTray( QWidget *parent = 0);
private slots:
    void systemTrayWindowAdded( WId id );
    void systemTrayWindowRemoved( );
protected:
    bool x11Event(XEvent *event);
private:
    QList<QX11EmbedWidget *> m_icons;
    QHBoxLayout *m_layout;
    int m_items;
};

#endif // SYSTEMTRAY_H
