/*
 * test.cpp : This program tests and shows how to use the label browser api
 */

#include<iostream>
#include"lbapi.h"

using namespace std;

//*********function declarations
void test_create_new_label();
void test_get_label();
void test_get_paths();
void test_get_paths();
void test_get_all_labels();
void test_create_label_with_comments();
void test_add_keywords_to_a_label();
void test_scanKeywordsAndAutomaticApply();
void test_searchLabels();
void test_hiddenLabels();
void test_deleteLabel();
void test_renameLabel();
void test_removeLabel();
void test_getAllXML();

int main()
{
	test_create_new_label();
	test_get_label();
	test_get_paths();
	test_get_all_labels();
	test_create_label_with_comments();
	test_add_keywords_to_a_label();
	test_scanKeywordsAndAutomaticApply();
	test_searchLabels();
	test_hiddenLabels();
	test_deleteLabel();
	test_renameLabel();
	test_removeLabel();
	test_getAllXML();
}

void test_create_new_label()
{
	cout <<" testing create label"<<endl;	
	KLB::LabelManager* testLabel = new KLB::LabelManager();
	testLabel->createLabel("rama");
//	testLabel->applyLabel("rama","/root/klb");
	
	//using Qstring 
	QString ss = "krishna";
	QString ss1 = "/var";
	testLabel->createLabel(ss);
	testLabel->applyLabel(ss,ss1);
	cout << "done"<<endl;
}

void test_get_label()
{
	cout <<" testing get label"<<endl;	
	KLB::LabelManager* testLabel = new KLB::LabelManager();
	QString ss = "hello";
	QString ss1 = "/root/hello";
	testLabel->createLabel(ss);
	testLabel->applyLabel(ss,ss1);
	
/*	testLabel->createLabel("hello");
	testLabel->applyLabel("hello","/root/hello");
*/
	QString path = "/root/hello";
	QStringList ss2 ;
	testLabel->getLabels(path,ss2);
	for ( QStringList::Iterator it = ss2.begin(); it != ss2.end(); ++it )
        {
            cout << *it << endl;
	}
	cout << "done"<<endl;
}

void test_get_paths()
{
	cout << "testing get paths"<<endl;
	KLB::LabelManager * testLabel = new KLB::LabelManager();
	QStringList ss;
	testLabel->getPaths("rama",ss);
	for ( QStringList::Iterator it = ss.begin(); it != ss.end(); ++it )
        {
            cout << *it << endl;
	}
	cout << "done"<<endl;
}

void test_get_all_labels()
{
	cout << "testing get all labels"<<endl;
	KLB::LabelManager * testLabel = new KLB::LabelManager();
	QStringList ss;
	testLabel->getAllLabels(ss);
	for ( QStringList::Iterator it = ss.begin(); it != ss.end(); ++it )
       {
            cout << *it << endl;
       }
	cout << "done"<<endl;
}

void test_create_label_with_comments()
{
	cout << "testing create label with comments" << endl;
	KLB::LabelManager* testLabel = new KLB::LabelManager();
	QString ss = "krishna-c";
	testLabel->createLabel(ss,"So it is commented now");
	cout << "done"<<endl;
}

void test_add_keywords_to_a_label()
{
	cout << "testing Addiing keywords for a label" << endl;
	KLB::LabelManager* testLabel = new KLB::LabelManager();
	QString ss = "rama-keywords";
	testLabel->createLabel(ss,"this label is for testing keyword addition");
	QStringList * keywords = new QStringList();
	keywords->append("keyword1");
	keywords->append("important");

	testLabel->addKeywords(ss,*keywords);
	cout << "done"<<endl;
}

void test_scanKeywordsAndAutomaticApply()
{
	cout <<  " testing scan key words and automatic apply" << endl;
	KLB::LabelManager* testLabel = new KLB::LabelManager();
	QString labelname ="Important"; 
	testLabel->createLabel(labelname);
	QStringList* keywords = new QStringList();
	keywords->append("important");
	keywords->append("precious");
	keywords->append("password");
	
	testLabel->addKeywords(labelname,*keywords);

	QString path= "file:/var/README";

	QStringList * words = new QStringList();
//suppose after scanning the above file by a scanner the following words are sent to api
	words->append("this");
	words->append("is");
	words->append("an");
	words->append("important");
	words->append("document");
	words->append("to");
	words->append("test");
	words->append("whether");
	words->append("the");
	words->append("labelbrowser");
	words->append("api");
	words->append("automatically");
	words->append("applies");
	words->append("the");
	words->append("label");
	words->append("important");
	words->append("to");
	words->append("this");
	words->append("file");

	testLabel->scanKeywordsAndAutomaticApply(path ,*words);
	
	cout << "done"<<endl;
}

void test_searchLabels()
{
	KLB::LabelManager* mgr = new KLB::LabelManager();
	cout<<"testing search labels" <<endl;
	mgr->createLabel("label1");
	mgr->createLabel("label2");

	mgr->applyLabel("label1","file:/root/var/");
	mgr->applyLabel("label2","file:/root/var/");
	mgr->applyLabel("label1","file:/root/tmp/");
	mgr->applyLabel("label2","file:/root/usr/");
	
	QStringList *paths = new QStringList();
	mgr->searchLabels(*paths,"names=\"label1\" or names=\"label2\"");

	cout << paths->size();
  	for ( QStringList::Iterator it = paths->begin(); it!=paths->end() ;it++)
	{
		cout << *it << endl;
	}
	cout <<" done" << endl;
}

void test_hiddenLabels()
{
	KLB::LabelManager * mgr = new KLB::LabelManager();
	cout << " testing hidden Labels " << endl;
	
	mgr->createLabel("hiddenLabel",KLB::HIDDEN);
	QStringList *allLabels = new QStringList();
	
	mgr->getAllLabels(*allLabels);
	cout<< " should not see \"hiddenLabel\" in the following list";
	for ( QStringList::Iterator it = allLabels->begin(); it!=allLabels->end() ;it++)
	{
		cout << *it << endl;
	}
	
	allLabels = new QStringList();
	mgr->getAllLabels(*allLabels,KLB::HIDDEN);
	cout<< " should see \"hiddenLabel\" in the following list";
	for ( QStringList::Iterator it = allLabels->begin(); it!=allLabels->end() ;it++)
	{
		cout << *it << endl;
	}

	cout <<" done" << endl;
}

void test_deleteLabel()
{
	KLB::LabelManager * mgr = new KLB::LabelManager();
	cout << " testing deletion of  Label " << endl;
	
	mgr->createLabel("del","hello world" ,KLB::HIDDEN);
	mgr->applyLabel("del","file:/var/");
	
//	char ss;
// 	cout<< "press any character to delete label del ";
//	cin >> ss;
	
	mgr->deleteLabel("del");
	cout << "done" <<endl;
		
}

void test_renameLabel()
{
	KLB::LabelManager * mgr = new KLB::LabelManager();
	cout << " testing renaming of  Label " << endl;
	
	mgr->createLabel("renold","hello world" ,KLB::HIDDEN);
	
//	char ss;
// 	cout<< "press any character to rename label renold to rennew ";
//	cin >> ss;
	
//	mgr->renameLabel("renold","rennew");
	cout << "done" <<endl;
}

void test_removeLabel()
{
	KLB::LabelManager * mgr = new KLB::LabelManager();
	cout << " testing removal of  Label for a path " << endl;
	
	mgr->applyLabel("rama","/var/wrongfile");
	
	char ss;
 	cout<< "press any character to remove label del ";
	cin >> ss;
	
	mgr->removeLabel("rama","/var/wrongfile");
	cout << "done" <<endl;
}

void test_getAllXML()
{
	KLB::LabelManager * mgr = new KLB::LabelManager();
	cout << " testing getAllXML functio of api " << endl;
	
	QString * temp = new QString();	
	
	mgr->getAllXML(*temp);
	cout << * temp;
	cout << "done" <<endl;
}
