#include "imagebrowser.h"

#include <KLocale>
#include <KDirModel>
#include <KDirLister>

#include <QListView>

#include <Nepomuk/Query/FileQuery>
#include <Nepomuk/Query/ResourceTypeTerm>

#include "nfo.h"


ImageBrowser::ImageBrowser()
    : KMainWindow()
{
    QListView* view = new QListView( this );
    setCentralWidget(view);

    KDirModel* model = new KDirModel( this );
    view->setModel(model);

    Nepomuk::Query::FileQuery query;
    query.setTerm( Nepomuk::Query::ResourceTypeTerm( Nepomuk::Vocabulary::NFO::RasterImage() ) );
    model->dirLister()->openUrl(query.toSearchUrl());
}

ImageBrowser::~ImageBrowser()
{
}

#include "imagebrowser.moc"
