/*
    This file is part of the Nepomuk KDE project.
    Copyright (C) 2010  Vishesh Handa <handa.vish@gmail.com>

    This program is free software: you can redistribute it and/or modify
    it under the terms of the GNU General Public License as published by
    the Free Software Foundation, either version 3 of the License, or
    (at your option) any later version.

    This program is distributed in the hope that it will be useful,
    but WITHOUT ANY WARRANTY; without even the implied warranty of
    MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
    GNU General Public License for more details.

    You should have received a copy of the GNU General Public License
    along with this program.  If not, see <http://www.gnu.org/licenses/>.
*/


#include "logfilehash.h"
#include "logfile.h"
#include "logfilerecord.h"

Nepomuk::LogFileHash Nepomuk::convertToLogFileHash(const Nepomuk::LogFile& logFile)
{
    LogFileHash hash;

    const QList<LogFileRecord> & records = logFile.allRecords();
    foreach( const LogFileRecord & r, records ) {
        QUrl sub = r.st.subject().uri();
        QUrl pred = r.st.predicate().uri();

        LogFileHashStruct s;
        s.object = r.st.object();
        s.added = r.added;
        s.dt = r.dateTime;

        LogFileHash::iterator it =  hash.find( sub );
        if( it == hash.end() )
            hash.insert( sub, LogFilePropHash() );

        LogFilePropHash & propHash = *hash.find( sub );
        propHash.insert( pred, s );
    }
    return hash;
}
