/*
Copyright (c) 2010 Oszkar Ambrus <aoszkar@gmail.com>

This library is free software; you can redistribute it and/or
modify it under the terms of the GNU Lesser General Public
License as published by the Free Software Foundation; either
version 2.1 of the License, or (at your option) version 3, or any
later version accepted by the membership of KDE e.V. (or its
successor approved by the membership of KDE e.V.), which shall
act as a proxy defined in Section 6 of version 3 of the license.

This library is distributed in the hope that it will be useful,
but WITHOUT ANY WARRANTY; without even the implied warranty of
MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU
Lesser General Public License for more details.

You should have received a copy of the GNU Lesser General Public
License along with this library.  If not, see <http://www.gnu.org/licenses/>.
*/

#ifndef CONTACTRESOURCEEDITPLUGIN_H
#define CONTACTRESOURCEEDITPLUGIN_H

#include "../src/abstractresourceeditplugin.h"

#include <QList>
#include <QVariant>

namespace Nepomuk {

    /**
      * Plugin to handle contact (tmo:Contact) resources
      */

    class ContactResourceEditPlugin : public AbstractResourceEditPlugin
    {
        Q_OBJECT;

    public:
        /**
         * Creates a new ContactResourceEditPlugin
         */
        ContactResourceEditPlugin(QWidget *parent = 0, const QList<QVariant>& = QList<QVariant>());
        ~ContactResourceEditPlugin();

        /**
          * @reimp from AbstractResourceEditPlugin
          */
        void saveChanges();

    private:
        /**
          * @reimp
          */
        void initGui();

        class Private;
        Private * const d;

    private Q_SLOTS:
        void loadContactPhoto();

        /**
          * @reimp
          */
        void setupActions();

        void startChat();
    };

}

#endif //CONTACTRESOURCEEDITPLUGIN_H
