/*
Copyright (c) 2010 Oszkar Ambrus <aoszkar@gmail.com>

This library is free software; you can redistribute it and/or
modify it under the terms of the GNU Lesser General Public
License as published by the Free Software Foundation; either
version 2.1 of the License, or (at your option) version 3, or any
later version accepted by the membership of KDE e.V. (or its
successor approved by the membership of KDE e.V.), which shall
act as a proxy defined in Section 6 of version 3 of the license.

This library is distributed in the hope that it will be useful,
but WITHOUT ANY WARRANTY; without even the implied warranty of
MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU
Lesser General Public License for more details.

You should have received a copy of the GNU Lesser General Public
License along with this library.  If not, see <http://www.gnu.org/licenses/>.
*/

#include "resourceeditdialog.h"
#include "resourceeditwidget.h"

#include <QWidget>
#include <Nepomuk/Query/ResourceTerm>


class Nepomuk::ResourceEditDialog::Private {
public:
    Nepomuk::ResourceEditWidget *editWidget;
    Nepomuk::Resource currentResource;
};

Nepomuk::ResourceEditDialog::ResourceEditDialog(const Nepomuk::Resource &resource, QWidget *parent, Qt::WFlags flags)
    : KDialog(parent, flags),
    d(new Private())
{
    setModal(true);
    setButtons(KDialog::Close);

    d->editWidget = new Nepomuk::ResourceEditWidget(this, resource);
    setMainWidget(d->editWidget);

    this->setWindowTitle(resource.uri());

    show();
}

Nepomuk::ResourceEditDialog::~ResourceEditDialog()
{
    delete d;
}

void Nepomuk::ResourceEditDialog::editResource(const Nepomuk::Resource &resource, QWidget *parent)
{
    Nepomuk::ResourceEditDialog dialog(resource, parent);
    dialog.exec();
}

