/*
Copyright (c) 2010 Oszkar Ambrus <aoszkar@gmail.com>

This library is free software; you can redistribute it and/or
modify it under the terms of the GNU Lesser General Public
License as published by the Free Software Foundation; either
version 2.1 of the License, or (at your option) version 3, or any
later version accepted by the membership of KDE e.V. (or its
successor approved by the membership of KDE e.V.), which shall
act as a proxy defined in Section 6 of version 3 of the license.

This library is distributed in the hope that it will be useful,
but WITHOUT ANY WARRANTY; without even the implied warranty of
MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU
Lesser General Public License for more details.

You should have received a copy of the GNU Lesser General Public
License along with this library.  If not, see <http://www.gnu.org/licenses/>.
*/

#ifndef PROPERTYEDITWIDGETTEST_H
#define PROPERTYEDITWIDGETTEST_H

#ifndef QT_GUI_LIB
#define QT_GUI_LIB
#endif

#include <QtTest>
#include <QtCore>
#include <QtGui>
#include <QObject>
#include <qtest_kde.h>

class QUrl;

namespace Nepomuk {
    class PropertyEditWidget;
    class Variant;
}

class PropertyEditWidgetTest : public QObject
{
    Q_OBJECT

public:
    PropertyEditWidgetTest(QObject *parent = 0);
    ~PropertyEditWidgetTest();

private:
    void performTestSteps(const QUrl &url, const Nepomuk::Variant &variant);

    Nepomuk::PropertyEditWidget *m_pew;

private Q_SLOTS:
    void testDate();
    void testDateTime();
    void testInt();
    void testString();
    void testDouble();
    void testBool();
    void testResource();
    void testStringMultiple();
    void testResourceMultiple();
};

#endif // PROPERTYEDITWIDGETTEST_H

