#ifndef FIELD_H
#define FIELD_H

#include <QList>
#include <QWidget>

#include "comparator.h"
#include "valuewidget.h"

typedef ValueWidget* (*widget_factory)(QWidget*);

class Field
{
public:
    Field(const QString& name, const QString& field, const QList<comparator>& comparators, widget_factory factory);

    const QString& name() const;
    const QString& field() const;
    const QList<comparator> comparators() const;
    ValueWidget* getWidget(QWidget* parent = NULL) const;

private:
    QString m_name;
    QString m_field;
    QList<comparator> m_comparators;
    widget_factory m_factory;
};

#endif // FIELD_H
