#include "valuewidget.h"

#include <QDateEdit>
#include <QLineEdit>

DateWidget::DateWidget(QWidget* parent) :
        widget(new QDateEdit(parent))
{
    connect(widget, SIGNAL(dateChanged(QDate)), this, SLOT(valueChanged(QDate)));

    valueChanged(widget->date());
}

DateWidget::~DateWidget()
{
    delete widget;
}

void DateWidget::valueChanged(const QDate& date)
{
    value = QString("\"%1\"").arg( widget->date().toString(Qt::ISODate) );
    emit valueUpdated(value);
}

QString DateWidget::getValue() const
{
    return value;
}

QWidget* DateWidget::getWidget()
{
    return widget;
}

SizeWidget::SizeWidget(QWidget* parent) :
        widget(new QLineEdit(parent))
{
    connect(widget, SIGNAL(textChanged(QString)), this, SLOT(valueChanged(QString)));
}

SizeWidget::~SizeWidget()
{
    delete widget;
}

void SizeWidget::valueChanged(const QString& size)
{
    value = QString("\"%1\"").arg(size);
    emit valueUpdated( value );
}

QString SizeWidget::getValue() const
{
    return value;
}

QWidget* SizeWidget::getWidget()
{
    return widget;
}
