#ifndef VALUEWIDGET_H
#define VALUEWIDGET_H

#include <QDate>
#include <QObject>
#include <QString>

class QWidget;
class QDateEdit;
class QLineEdit;

class ValueWidget : public QObject
{
    Q_OBJECT
public:
    virtual ~ValueWidget() {}

    virtual QString  getValue() const = 0;
    virtual QWidget* getWidget() = 0;

signals:
    void valueUpdated(QString value);
};

class DateWidget : public ValueWidget
{
    Q_OBJECT
public:
    DateWidget(QWidget* parent = NULL);
    ~DateWidget();

    QString  getValue() const;
    QWidget* getWidget();

private slots:
    void valueChanged(const QDate& date);

private:
    DateWidget(const DateWidget& o);
    const DateWidget& operator=(const DateWidget& o);

    QString value;
    QDateEdit* widget;
};

class SizeWidget : public ValueWidget
{
    Q_OBJECT
public:
    SizeWidget(QWidget* parent = NULL);
    ~SizeWidget();

    QString  getValue() const;
    QWidget* getWidget();

private slots:
    void valueChanged(const QString& size);

private:
    SizeWidget(const SizeWidget& o);
    const SizeWidget& operator=(const SizeWidget& o);

    QString value;
    QLineEdit* widget;
};

#endif // VALUEWIDGET_H
