/*
  Copyright (C) 2010 Michael Leupold <lemma@confuego.org>

  This library is free software; you can redistribute it and/or
  modify it under the terms of the GNU Lesser General Public
  License as published by the Free Software Foundation; either
  version 2.1 of the License, or (at your option) any later version.

  This library is distributed in the hope that it will be useful,
  but WITHOUT ANY WARRANTY; without even the implied warranty of
  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU
  Lesser General Public License for more details.

  You should have received a copy of the GNU Lesser General Public
  License along with this library; if not, write to the Free Software
  Foundation, Inc., 51 Franklin Street, Fifth Floor, Boston, MA  02110-1301  USA
*/

#ifndef PAM_KWALLET_HASH_H
#define PAM_KWALLET_HASH_H

/**
 * Hash the password using multiple rounds of SHA-1.
 *
 * @param hash (output) the password hash. This array has to be at least 56 bytes long
 * @param hashsz (output) the actual password hash length
 * @param password (input) password to hash
 * @param passwordsz (input) input password length
 */
void password_to_hash(unsigned char *hash, int *hashsz,
                      const unsigned char *password, int passwordsz);

#endif
