/***************************************************************************
 *                                                                         *
 *   This program is free software; you can redistribute it and/or modify  *
 *   it under the terms of the GNU General Public License as published by  *
 *   the Free Software Foundation; either version 2 of the License, or     *
 *   (at your option) any later version.                                   *
 *                                                                         *
 *   Copyright (C) 2008 by Dennis Nienhüser <earthwings@gentoo.org>        *
 *                                                                         *
 *   This program is distributed in the hope that it will be useful,       *
 *   but WITHOUT ANY WARRANTY; without even the implied warranty of        *
 *   MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the         *
 *   GNU General Public License for more details.                          *
 *                                                                         *
 *   You should have received a copy of the GNU General Public License     *
 *   along with this program; if not, write to the                         *
 *   Free Software Foundation, Inc.,                                       *
 *   51 Franklin Street, Fifth Floor, Boston, MA  02110-1301  USA .        *
 ***************************************************************************/

#include "contactactions.h"

#include <QtCore/QStringList>
#include <QtDBus/QDBusInterface>
#include <QtDBus/QDBusReply>

ContactActions *ContactActions::m_instance = 0;

ContactActions::ContactActions()
{
	// nothing to do
}

ContactActions *ContactActions::self()
{
	if (!m_instance)
	{
		m_instance = new ContactActions();
	}

	Q_ASSERT(m_instance);
	return m_instance;
}

void ContactActions::sendMessageKopete(const QString &receiver,
		const QString &message)
{
	QDBusInterface kopete("org.kde.kopete", "/Kopete");
	if (kopete.isValid())
	{
		kopete.call("sendMessage", receiver, message);
	}
}


void ContactActions::openChatKopete(const QString &contactId)
{
    QDBusInterface kopete("org.kde.kopete", "/Kopete");
    if (kopete.isValid())
    {
        kopete.call("openChat", contactId);
    }    
}
