/***************************************************************************
 *                                                                         *
 *   This program is free software; you can redistribute it and/or modify  *
 *   it under the terms of the GNU General Public License as published by  *
 *   the Free Software Foundation; either version 2 of the License, or     *
 *   (at your option) any later version.                                   *
 *                                                                         *
 *   Copyright (C) 2008 by Dennis Nienhüser <earthwings@gentoo.org>        *
 *                                                                         *
 *   This program is distributed in the hope that it will be useful,       *
 *   but WITHOUT ANY WARRANTY; without even the implied warranty of        *
 *   MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the         *
 *   GNU General Public License for more details.                          *
 *                                                                         *
 *   You should have received a copy of the GNU General Public License     *
 *   along with this program; if not, write to the                         *
 *   Free Software Foundation, Inc.,                                       *
 *   51 Franklin Street, Fifth Floor, Boston, MA  02110-1301  USA .        *
 ***************************************************************************/

#ifndef CONTACT_ACTIONS_H_
#define CONTACT_ACTIONS_H_

#include "abstractcell.h"

#include <QtCore/QObject>

/**
 * Similar to KToolInvocation, this class provides some useful actions
 */
class ContactActions: public QObject
{
Q_OBJECT

public:
	/**
	 * Singleton accessor
	 */
	static ContactActions *self();

public Q_SLOTS:
	/**
	 * Send a message to a contact in Kopete. Won't do anything if Kopete isn't running
	 * @param receiver The message receiver (displayName in Kopete)
	 * @param message Message to send
	 */
	static void sendMessageKopete(const QString &receiver, const QString &message);
	
	/**
	 * Open a chat with a kopete contact
	 * @param contactId Contact id triplet of the contact
	 */
	static void openChatKopete(const QString &contactId);

private:
	/** Private (singleton) constructor */
	ContactActions();

	/** Singleton instance */
	static ContactActions *m_instance;
};

#endif // CONTACT_ACTIONS_H_
