/***************************************************************************
 *                                                                         *
 *   This program is free software; you can redistribute it and/or modify  *
 *   it under the terms of the GNU General Public License as published by  *
 *   the Free Software Foundation; either version 2 of the License, or     *
 *   (at your option) any later version.                                   *
 *                                                                         *
 *   Copyright (C) 2008 by Dennis Nienhüser <earthwings@gentoo.org>        *
 *                                                                         *
 *   This program is distributed in the hope that it will be useful,       *
 *   but WITHOUT ANY WARRANTY; without even the implied warranty of        *
 *   MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the         *
 *   GNU General Public License for more details.                          *
 *                                                                         *
 *   You should have received a copy of the GNU General Public License     *
 *   along with this program; if not, write to the                         *
 *   Free Software Foundation, Inc.,                                       *
 *   51 Franklin Street, Fifth Floor, Boston, MA  02110-1301  USA .        *
 ***************************************************************************/

#ifndef GLOBAL_WIDGET_H_
#define GLOBAL_WIDGET_H_

#include <QtGui/QGraphicsWidget>

/**
 * Widget to display information about all contacts and/or actions to communicate with them.
 */
class GlobalWidget: public QGraphicsWidget
{
Q_OBJECT

public:
	/**
	 * Constructor
	 * @param parent Parent widget
	 */
	GlobalWidget(QGraphicsItem *parent = 0)	;

	/** Destructor */
	virtual ~GlobalWidget();

	/** Update properties of a contact
	 * @param id Contact id
	 * @param properties Contacts properties
	 */
	virtual void propertiesChanged(const QString &id, const QVariantMap &properties);
};

#endif // GLOBAL_WIDGET_H_
