/*****************************************************************************
 *   Copyright (C) 2009-2010 by Matthieu Gallien <matthieu_gallien@yahoo.fr> *
 *   Copyright (C) 2007 by Robert Knight <robertknight@gmail.com>          *
 *   Copyright (C) 2008 by Alexis Ménard <darktears31@gmail.com>           *
 *                                                                           *
 *   This program is free software; you can redistribute it and/or modify    *
 *   it under the terms of the GNU General Public License as published by    *
 *   the Free Software Foundation; either version 2 of the License, or       *
 *   (at your option) any later version.                                     *
 *                                                                           *
 *   This program is distributed in the hope that it will be useful,         *
 *   but WITHOUT ANY WARRANTY; without even the implied warranty of          *
 *   MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the           *
 *   GNU General Public License for more details.                            *
 *                                                                           *
 *   You should have received a copy of the GNU General Public License       *
 *   along with this program; if not, write to the                           *
 *   Free Software Foundation, Inc.,                                         *
 *   51 Franklin Street, Fifth Floor, Boston, MA  02110-1301  USA .          *
 *****************************************************************************/

#ifndef DATAENGINES_TASKS_HEADER
#define DATAENGINES_TASKS_HEADER

#include <Plasma/Applet>

class QAbstractItemModel;
class TasksView;

namespace Plasma
{
    class FrameSvg;
}

class DataEnginesTasks : public Plasma::Applet
{
    Q_OBJECT
public:

    DataEnginesTasks(QObject *parent, const QVariantList &args);
    ~DataEnginesTasks();

    void init();

    void constraintsEvent(Plasma::Constraints constraints);

    Plasma::FrameSvg *itemBackground();

    qreal itemLeftMargin() { return m_leftMargin; }
    qreal itemRightMargin() { return m_rightMargin; }
    qreal itemTopMargin() { return m_topMargin; }
    qreal itemBottomMargin() { return m_bottomMargin; }
    qreal offscreenLeftMargin() { return m_offscreenLeftMargin; }
    qreal offscreenRightMargin() { return m_offscreenRightMargin; }
    qreal offscreenTopMargin() { return m_offscreenTopMargin; }
    qreal offscreenBottomMargin() { return m_offscreenBottomMargin; }
    void resizeItemBackground(const QSizeF &newSize);

    void needsVisualFocus();

private:
    QAbstractItemModel *m_model;
    TasksView *m_graphicsView;

    Plasma::FrameSvg *m_taskItemBackground;
    qreal m_leftMargin;
    qreal m_topMargin;
    qreal m_rightMargin;
    qreal m_bottomMargin;
    qreal m_offscreenLeftMargin;
    qreal m_offscreenTopMargin;
    qreal m_offscreenRightMargin;
    qreal m_offscreenBottomMargin;
};

#endif
