/***************************************************************************
 *   Copyright (C) 2010 by Matthieu Gallien <matthieu_gallien@yahoo.fr>    *
 *                                                                         *
 *   This program is free software; you can redistribute it and/or modify  *
 *   it under the terms of the GNU General Public License as published by  *
 *   the Free Software Foundation; either version 2 of the License, or     *
 *   (at your option) any later version.                                   *
 *                                                                         *
 *   This program is distributed in the hope that it will be useful,       *
 *   but WITHOUT ANY WARRANTY; without even the implied warranty of        *
 *   MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the         *
 *   GNU General Public License for more details.                          *
 *                                                                         *
 *   You should have received a copy of the GNU General Public License     *
 *   along with this program; if not, write to the                         *
 *   Free Software Foundation, Inc.,                                       *
 *   51 Franklin Street, Fifth Floor, Boston, MA  02110-1301  USA .        *
 ***************************************************************************/

#ifndef SERVICE_MODEL_ACTION_HEADER
#define SERVICE_MODEL_ACTION_HEADER

#include <QAction>
#include <QVariantMap>
#include <QString>

namespace Plasma
{
    class Service;
}

class ServiceAction : public QAction
{

    Q_OBJECT

public:

    ServiceAction(QObject *parent,
                  Plasma::Service *taskService,
                  Plasma::Service *statusItemService,
                  const QVariantMap &parameters);

private slots:

    void activeService();

private:

    Plasma::Service *m_service;
    QString m_operationName;
    QVariantMap m_extraOperationParameters;
};

#endif
