/*
 *   Copyright (C) 2009 Nokia Corporation and/or its subsidiary(-ies).
 *   Copyright © 2009 Reza Fatahilah Shah <rshah0385@kireihana.com>
 *
 *   This program is free software; you can redistribute it and/or
 *   modify it under the terms of the GNU Lesser Library General Public
 *   License as published by the Free Software Foundation; either
 *   version 2 of the License, or (at your option) any later version.
 *
 *   This library is distributed in the hope that it will be useful,
 *   but WITHOUT ANY WARRANTY; without even the implied warranty of
 *   MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU
 *   Library General Public License for more details.
 *
 *   You should have received a copy of the GNU Library General Public License
 *   along with this library; see the file COPYING.LIB.  If not, write to
 *   the Free Software Foundation, Inc., 51 Franklin Street, Fifth Floor,
 *   Boston, MA 02110-1301, USA.
 */
/*
    This code is slim version of phonon one
*/

#include "abstractrenderer.h"
#include <gst/gst.h>
AbstractRenderer::~AbstractRenderer()
{
    if (m_videoSink) {
        gst_object_unref (GST_OBJECT (m_videoSink)); //Take ownership
        m_videoSink = 0;
    }
}

void AbstractRenderer::aspectRatioChanged(Phonon::VideoWidget::AspectRatio aspectRatio)
{
    Q_UNUSED(aspectRatio);
}

void AbstractRenderer::scaleModeChanged(Phonon::VideoWidget::ScaleMode scaleMode)
{
    Q_UNUSED(scaleMode);
}

void AbstractRenderer::movieSizeChanged(const QSize &size)
{
    Q_UNUSED(size);
}
