/*
 *   Copyright (C) 2009 George Kiagiadakis <kiagiadakis.george@gmail.com>
 *   Copyright © 2009 Reza Fatahilah Shah <rshah0385@kireihana.com>
 *
 *   This program is free software; you can redistribute it and/or
 *   modify it under the terms of the GNU Lesser Library General Public
 *   License as published by the Free Software Foundation; either
 *   version 2 of the License, or (at your option) any later version.
 *
 *   This library is distributed in the hope that it will be useful,
 *   but WITHOUT ANY WARRANTY; without even the implied warranty of
 *   MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU
 *   Library General Public License for more details.
 *
 *   You should have received a copy of the GNU Lesser Library General Public License
 *   along with this library; see the file COPYING.LIB.  If not, write to
 *   the Free Software Foundation, Inc., 51 Franklin Street, Fifth Floor,
 *   Boston, MA 02110-1301, USA.
 */
#include "videoproxywidget.h"
#include <QGraphicsSceneResizeEvent>
#include <KDebug>
/***************************************************************************
 *   Copyright © 2009 Reza Fatahilah Shah <rshah0385@kireihana.com>        *
 *                                                                         *
 *   This program is free software; you can redistribute it and/or modify  *
 *   it under the terms of the GNU General Public License as published by  *
 *   the Free Software Foundation; either version 2 of the License, or     *
 *   (at your option) any later version.                                   *
 *                                                                         *
 *   This program is distributed in the hope that it will be useful,       *
 *   but WITHOUT ANY WARRANTY; without even the implied warranty of        *
 *   MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the         *
 *   GNU General Public License for more details.                          *
 *                                                                         *
 *   You should have received a copy of the GNU General Public License     *
 *   along with this program; if not, write to the                         *
 *   Free Software Foundation, Inc.,                                       *
 *   51 Franklin Street, Fifth Floor, Boston, MA  02110-1301  USA .        *
 ***************************************************************************/
#include "renderer/videowidget.h"
#include "libqtgstreamer/qgstelementfactory.h"
#include "libqtgstreamer/qgstelement.h"
/*#include "libkgstdevices/abstractrenderer.h"
#include "libkgstdevices/overlayrenderer.h"
#include "libkgstdevices/videowidget.h"*/


VideoProxyWidget::VideoProxyWidget(QGraphicsWidget *parent,QString renderType)
    : QGraphicsProxyWidget(parent),mVideoWidget(0)
{
    /*using namespace KGstDevices;

    AbstractRenderer *renderer = createRenderer(renderType);
    renderer->setAspectRatio(AbstractRenderer::AspectRatioWidget);
    mVideoWidget = KGstDevices::VideoWidget::newVideoWidget(renderer,0);
    if (mVideoWidget) {
        setWidget(mVideoWidget);

        mVideoWidget->show();
        mVideoWidget->videoBin()->setState(QtGstreamer::QGstElement::Ready);
    }
    else {
        delete renderer;
    }*/
    mVideoWidget = new VideoWidget(0,renderType);
    setWidget(mVideoWidget);
}

VideoProxyWidget::~VideoProxyWidget()
{
}

/*KGstDevices::AbstractRenderer *VideoProxyWidget::createRenderer(QString &rendererType)
{
    using namespace QtGstreamer;

    QGstElementPtr element = QGstElementFactory::make(rendererType.toLatin1());
    if ( element.isNull() ) {
        kWarning() << "Could not construct" << rendererType;
        return NULL;
    }

    KGstDevices::AbstractRenderer *renderer = new KGstDevices::OverlayRenderer(element);
    return renderer;
}*/

/*KGstDevices::VideoWidget *VideoProxyWidget::nativeWidget()
{
    return mVideoWidget;
}*/

VideoWidget *VideoProxyWidget::nativeWidget()
{
    return mVideoWidget;
}

void VideoProxyWidget::resizeEvent(QGraphicsSceneResizeEvent *event)
{
    QGraphicsProxyWidget::resizeEvent(event);

    if (mVideoWidget) {
        mVideoWidget->resize(event->newSize().width(), event->newSize().height());
    }
}