/*
 *   Copyright 2008 by Andrea Diamantini <adjam7@gmail.com>
 *
 *   This program is free software; you can redistribute it and/or modify
 *   it under the terms of the GNU Library General Public License as
 *   published by the Free Software Foundation; either version 2, or
 *   (at your option) any later version.
 *
 *   This program is distributed in the hope that it will be useful,
 *   but WITHOUT ANY WARRANTY; without even the implied warranty of
 *   MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 *   GNU General Public License for more details
 *
 *   You should have received a copy of the GNU Library General Public
 *   License along with this program; if not, write to the
 *   Free Software Foundation, Inc.,
 *   51 Franklin Street, Fifth Floor, Boston, MA  02110-1301, USA.
 */


#ifndef KONSOLATOR_HEADER
#define KONSOLATOR_HEADER

#include <QGraphicsProxyWidget>
#include <QGraphicsLinearLayout>

#include <Plasma/PopupApplet>
#include <Plasma/Svg>

class QSizeF;
class TerminalInterface;

// Define our plasma Applet
class Konsolator : public Plasma::PopupApplet //QGraphicsWidget
{
    Q_OBJECT
    public:
        Konsolator(QObject *parent, const QVariantList &args);
        ~Konsolator();

    protected:
        virtual QWidget *widget();

    private:
        QWidget *m_widget;
        TerminalInterface *m_terminal;
        bool m_failed;
};

// This is the command that links your applet to the .desktop file
K_EXPORT_PLASMA_APPLET(konsolator, Konsolator)
#endif
