/***************************************************************************
 *   Copyright (C) 2009 by Björn Ruberg <bjoern@ruberg-wegener.de>         *
 *                                                                         *
 *   This program is free software; you can redistribute it and/or modify  *
 *   it under the terms of the GNU General Public License as published by  *
 *   the Free Software Foundation; either version 2 of the License, or     *
 *   (at your option) any later version.                                   *
 *                                                                         *
 *   This program is distributed in the hope that it will be useful,       *
 *   but WITHOUT ANY WARRANTY; without even the implied warranty of        *
 *   MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the         *
 *   GNU General Public License for more details.                          *
 *                                                                         *
 *   You should have received a copy of the GNU General Public License     *
 *   along with this program; if not, write to the                         *
 *   Free Software Foundation, Inc.,                                       *
 *   51 Franklin Street, Fifth Floor, Boston, MA  02110-1301  USA .        *
 ***************************************************************************/

#include "contactslist.h"
#include <QList>
#include <plasma/applet.h>
#include <plasma/widgets/label.h>
#include <plasma/widgets/scrollwidget.h>
#include "contact.h"
#include "contactlistitem.h"

ContactsList::ContactsList(QGraphicsWidget *parent) :
	Plasma::ScrollWidget(parent)
{
    setMinimumSize(100, 100);
    setContentsMargins(0,0,0,0);
    setMaximumSize(INT_MAX,INT_MAX);
    setPreferredSize(200,500);
    setSizePolicy(QSizePolicy::Minimum, QSizePolicy::Minimum);

    m_widget = new Plasma::Applet(this);

    m_layout = new QGraphicsLinearLayout(m_widget);
    m_layout->setOrientation( Qt::Vertical );
    m_layout->setSpacing(1);

    setWidget(m_widget);
}

ContactsList::~ContactsList()
{
}

void ContactsList::updateList( QList<Contact*> contacts) {

    ContactListItem *item;
    while ( m_layout->count() > 0 ) {
	item = (ContactListItem*) m_layout->itemAt(0);
	m_layout->removeAt(0);
	item->setVisible(false);
    }

    foreach (Contact* contact, contacts) {
	ContactListItem* item = contact->getListItem(this);
	item->setVisible(true);
	m_layout->addItem(item);
    }

}
