// Here we avoid loading the header multiple times
#ifndef KPARTAPPLET_HEADER
#define KPARTAPPLET_HEADER
//KDE
#include <Plasma/Applet>
#include <KParts/ReadOnlyPart>

//Widgets
#include <plasma/widgets/lineedit.h>
#include <plasma/widgets/groupbox.h>
#include <Plasma/ScrollWidget>

//Config
#include "ui_kpartapplet_config.h"

class QSizeF;
class QGraphicsLinearLayout;

// Define our plasma Applet
class KPartApplet : public Plasma::Applet
{
    Q_OBJECT
    public:
        // Basic Create/Destroy
        KPartApplet(QObject *parent, const QVariantList &args);
        ~KPartApplet();

        void init();
	void reloadConfiguration();
	void createConfigurationInterface(KConfigDialog *parent);

        enum PartType { ReadOnly, ReadWrite };
	
    public slots:
        void configAccepted();
	void urlChanged();
    void loadToolbox();

    private:
        QHash<KService::Ptr, PartType> m_parts;
	QGraphicsLinearLayout* m_layout;
	KUrl m_url;
	QString m_partName;
	KParts::ReadOnlyPart* m_part;
	Ui::Config m_ui;
	Plasma::LineEdit* m_url_edit;
	QGraphicsProxyWidget* m_part_widget;
	KConfigGroup m_cg;
	Plasma::ScrollWidget* m_toolbox;
	bool m_nopart;
	
	bool partIsAlreadyListed(KService::Ptr service);
	QGraphicsProxyWidget* loadKPart();
	void loadKPartsList();
	void updateUI();
};
 
// This is the command that links your applet to the .desktop file
K_EXPORT_PLASMA_APPLET(kpartapplet, KPartApplet)
#endif
