/***************************************************************************
 *   Copyright (C) 2009 by Björn Ruberg <bjoern@ruberg-wegener.de>         *
 *                                                                         *
 *   This program is free software; you can redistribute it and/or modify  *
 *   it under the terms of the GNU General Public License as published by  *
 *   the Free Software Foundation; either version 2 of the License, or     *
 *   (at your option) any later version.                                   *
 *                                                                         *
 *   This program is distributed in the hope that it will be useful,       *
 *   but WITHOUT ANY WARRANTY; without even the implied warranty of        *
 *   MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the         *
 *   GNU General Public License for more details.                          *
 *                                                                         *
 *   You should have received a copy of the GNU General Public License     *
 *   along with this program; if not, write to the                         *
 *   Free Software Foundation, Inc.,                                       *
 *   51 Franklin Street, Fifth Floor, Boston, MA  02110-1301  USA .        *
 ***************************************************************************/

#ifndef SCREENCONTROL_H
#define SCREENCONTROL_H

#include <QGraphicsWidget>

#include <plasma/applet.h>
#include <kephal/configurations.h>
#include <kephal/screens.h>
#include <plasma/widgets/iconwidget.h>

class QGraphicsLinearLayout;
class OutputFrame;

namespace Plasma
{
    class TabBar;

}


class ScreenControl : public QGraphicsWidget
{
    Q_OBJECT
public:
    ScreenControl(QGraphicsWidget *parent);
    ~ScreenControl();

public:
    enum Mode {
	single,
	clone,
	leftOf,
	rightOf,
	stacked
    };

private:
    void enableScreenButtons();
    ScreenControl::Mode detectScreenMode();
    void selectScreenMode();

private Q_SLOTS:
    void init();
    void acceptConfiguration();
    void disableScreenButtons();


private:
    QGraphicsLinearLayout* m_rows;
    QGraphicsLinearLayout* m_screen_row;
    Plasma::TabBar* m_tabbar;
    QList<OutputFrame *> m_outputs;
    Kephal::Configuration* m_configuration;
    Kephal::Screen* m_screen;
    Plasma::IconWidget* m_acceptIcon;
};

#endif // SCREENCONTROL_H
