/***************************************************************************
 *   Copyright 2008 by Beat Wolf <asraniel@fryx.ch>                        *
 *                                                                         *
 *   This program is free software; you can redistribute it and/or modify  *
 *   it under the terms of the GNU General Public License as published by  *
 *   the Free Software Foundation; either version 2 of the License, or     *
 *   (at your option) any later version.                                   *
 *                                                                         *
 *   This program is distributed in the hope that it will be useful,       *
 *   but WITHOUT ANY WARRANTY; without even the implied warranty of        *
 *   MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the         *
 *   GNU General Public License for more details.                          *
 *                                                                         *
 *   You should have received a copy of the GNU General Public License     *
 *   along with this program; if not, write to the                         *
 *   Free Software Foundation, Inc.,                                       *
 *   51 Franklin Street, Fifth Floor, Boston, MA  02110-1301  USA .        *
 ***************************************************************************/

#ifndef SERVERAPPLETCONFIG_HEADER
#define SERVERAPPLETCONFIG_HEADER

//#include "serverapplet.h"

#include <QLineEdit>
#include <QDialog>
#include <KConfigGroup>
#include <QButtonGroup>
#include <QCheckBox>

struct service{
    QString name;
    QString protocol;
    QString icon;
    uint type;
};

enum service_types{
    SERVICE,
    SHELL
};

class Configuration : public QDialog
{
    Q_OBJECT
    public:
        // Basic Create/Destroy
        Configuration(const KConfigGroup &con, QList<struct service> *services);
        ~Configuration();

    public slots:
	void ok();
	void cancel();
    private:
      KConfigGroup m_config;

      QLineEdit *name;
      QLineEdit *hostAddress;
      QLineEdit *userName;

      QButtonGroup *m_service_choices;
      QList<struct service> *base_services;
};

#endif
