#include "sessionplasmoid.h"
// Plasma
#include <Plasma/Svg>
#include <Plasma/Theme>
// Qt
#include <QPainter>
#include <QFontMetrics>
#include <QSizeF>

namespace Plasma
{

SessionPlasmoid::SessionPlasmoid( QObject* parent, const QVariantList& args )
  : Applet( parent, args ),
    mSvg( this ),
    mIcon( "document" )
{
    mSvg.setImagePath( "widgets/background" );
    // this will get us the standard applet background, for free!
    setBackgroundHints(DefaultBackground);
    resize(200, 200);
}


void SessionPlasmoid::init()
{
    // A small demonstration of the setFailedToLaunch function
    if (mIcon.isNull()) {
        setFailedToLaunch(true, "No world to say hello");
    }
}


void SessionPlasmoid::paintInterface( QPainter* painter,
        const QStyleOptionGraphicsItem* option, const QRect& contentsRect )
{
    painter->setRenderHint( QPainter::SmoothPixmapTransform );
    painter->setRenderHint( QPainter::Antialiasing );

    // Now we draw the applet, starting with our svg
    mSvg.resize( (int)contentsRect.width(), (int)contentsRect.height() );
    mSvg.paint( painter, (int)contentsRect.left(), (int)contentsRect.top() );

    // We place the icon and text
    painter->drawPixmap( 7, 0, mIcon.pixmap((int)contentsRect.width(),(int)contentsRect.width()-14) );
    painter->save();
    painter->setPen(Qt::white);
    painter->drawText(contentsRect,
                Qt::AlignBottom | Qt::AlignHCenter,
                "Hello Plasmoid!");
    painter->restore();
}

SessionPlasmoid::~SessionPlasmoid()
{
    if (hasFailedToLaunch()) {
        // Do some cleanup here
    } else {
        // Save settings
    }
}

}
