#ifndef dialog_helper_h
#define dialog_helper_h
/*
# * Copyright(c) 2008 Matthew Adams <roguestar191 at comcast.net>
# *
# * This program is free software; you can redistribute it and/or
# * modify it under the terms of the GNU General Public License as
# * published by the Free Software Foundation; either version 2 of
# * the License, or(at your option) any later version.
# *
# * This program is distributed in the hope that it will be useful,
# * but WITHOUT ANY WARRANTY; without even the implied warranty of
# * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
# * GNU General Public License for more details.
# *
# * You should have received a copy of the GNU General Public License
# * along with this program.  If not, see <http//www.gnu.org/licenses/>.
# */

namespace welcome_plasmoid {
	class AboutHelper : public Plasma::Dialog {
		Q_OBJECT
		public:
			AboutHelper(parent=NULL)
			void init()
			void paintInterface()
		public slots:
			void accept()
			void reject()
	}
	template <class Top, class App>
	class DialogHelper : public Plasma::Dialog {
		Top* top;
		Top* mytop;
		Q_OBJECT
		QString source
		QString lastsource
		
		public:	
			DialogHelper(parent=NULL, realparent=NULL, top=NULL);
			void settop(Top*, App* );
			void runUrlInBackground();
		public slots:
			void ToTDPreviousButtonClicked(); 
			void ToTDNextButtonClicked();
			void aboutButtonClicked();
			void PGetStartedClicked();
			void KGetStartedClicked();
			void KGeneralDocClicked();
			void PAPIWebsiteClicked();
			void PWebsiteClicked();
			void PlasmoidsInfoClicked();
			void KDEWebsiteClicked();
			void PActivitiesClicked();
			void accept(); // accept/reject what?.. nothing apparently.. Oh it's for the about dialog? no longer used...
			void reject();
			void changedSelection(QString);
			void urlLink(QUrl);
			void runUrlBackground();
			void progressBar(int);
			void systemsettings();
			void packagemanager();
			void systemlogs();
			void konsole();
			void favoritePick(QListWidgetItem*);
			void addToFavorites();
			void remFavorite();
			void setUrlPlasma(); 
			void setUrl(QString);  
			void urlLinkupdate(QUrl); 
			bool sizeGripEnabled; // Again, qt generated ui files...
			bool modal; // Qt generated ui files
//			void *layout; // Find out what kind this should be, and if it's even used..
			welcomePlasmoid &dialog; // the actual dialog object
			QGraphicsProxyWidget &proxy; // If plasmadialog is false, use this to embed the dialog into a plasma themed 	applet..
			QGraphicsWidget &widget; // a widget for the proxy
			QString objectName; // For the qt generated ui files...
			bool plasmaDialog; // True if it's a plasma dialog, false otherwise..
		private:
			template <class T>
				void findTipFiles(T& tipFileBox);
			template <class T>
				void rep(T& node);
			void replInHtml(QString&);
			void addUrlToHistory(KUrl&);
		private slots:
	};
};
#endif
