/*
# * Copyright(c) 2008 Matthew Adams <roguestar191 at comcast.net>
# *
# * This program is free software; you can redistribute it and/or
# * modify it under the terms of the GNU General Public License as
# * published by the Free Software Foundation; either version 2 of
# * the License, or(at your option) any later version.
# *
# * This program is distributed in the hope that it will be useful,
# * but WITHOUT ANY WARRANTY; without even the implied warranty of
# * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
# * GNU General Public License for more details.
# *
# * You should have received a copy of the GNU General Public License
# * along with this program.  If not, see <http//www.gnu.org/licenses/>.
# */
#ifndef Ui_DIALOG_H
#define Ui_DIALOG_H
#include <Ui_PlasmaTools.h>
#include <Plasma/PopupApplet>
//#include <plasma/applet.h>
#include <Ui_LinksTab.h>
#include <Ui_Browser.h>
#include <Ui_WelcomeTab.h>

#include <vector>
#include "../source/tabbar.h"
class PlasmaWelcome;
namespace welcome_plasmoid {
	class Ui_WelcomePlasmoid : public QGraphicsWidget, public LinksTab, public TipBrowser, public WelcomeTab {
		Q_OBJECT
		public:	
			float factor;
			float maxWave;
			float maxRise;
			bool GlowAnimation;
			bool FadeAnimation;
			bool EXITING;
			PlasmaWelcome *top;
			
			Ui_WelcomePlasmoid(PlasmaWelcome*top);
			~Ui_WelcomePlasmoid();
			Plasma::FrameSvg backgroundImage;
			welcome_plasmoid::TabBar *tabWidget;
			ResizeFrame *topFrame;
			QGraphicsLinearLayout *gridLayout;
			QGraphicsGridLayout *topLayout;
			GloweyLabel *welcomeUsernameLabel;

			virtual void retranslate_ui(Plasma::PopupApplet&);
			virtual void retranslateUi(Plasma::PopupApplet&);
			virtual QString translate(QString& strin);
			virtual Plasma::IconWidget *addTool(QString iconstring, QGraphicsLinearLayout &layout);
			virtual Plasma::IconWidget *addToolNoLayout(QString iconstring);
			void invalidateLayouts();			
			std::vector<Plasma::Label> mychildren; // badly named... but contain all the labels for %i %u %f replacements in their text
			bool webpageloaded;
			int zoom_factor;
			bool plasma; // set to true
			void setupUi( Plasma::PopupApplet& welcomePlasmoid );
			void resizeEvent(QGraphicsSceneResizeEvent *e);
			void createTopFrame();
			void retranslateUi();
			void tabChanged(int index);
			void configChanged();
		public slots:
			void setCurrentUrl(QString);
			void addBookmark(QString& title, QString&url);
	};
}
#endif
