/*
# * Copyright(c) 2008 Matthew Adams <roguestar191 at comcast.net>
# *
# * This program is free software; you can redistribute it and/or
# * modify it under the terms of the GNU General Public License as
# * published by the Free Software Foundation; either version 2 of
# * the License, or(at your option) any later version.
# *
# * This program is distributed in the hope that it will be useful,
# * but WITHOUT ANY WARRANTY; without even the implied warranty of
# * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
# * GNU General Public License for more details.
# *
# * You should have received a copy of the GNU General Public License
# * along with this program.  If not, see <http//www.gnu.org/licenses/>.
# */
#ifndef UI_DIALOG_CPP
#define UI_DIALOG_CPP
#include "../includes/Ui_Dialog.h"
#include "../includes/Ui_BackgroundWidget.h"
#include "../welcome.h"
#include <QtDebug>

namespace welcome_plasmoid {
	Ui_WelcomePlasmoid::~Ui_WelcomePlasmoid() {
		EXITING = true;
	}
	Ui_WelcomePlasmoid::Ui_WelcomePlasmoid(PlasmaWelcome*_top) : QGraphicsWidget(_top->graphicsWidget()), LinksTab(this), TipBrowser(this), WelcomeTab(this), EXITING(false), top(_top)
	{
		tabWidget = new welcome_plasmoid::TabBar(_top->graphicsWidget(),false);
		gridLayout = new QGraphicsLinearLayout(Qt::Vertical, _top->graphicsWidget());
		welcomeUsernameLabel = new GloweyLabel();

		gridLayout->setMaximumSize(167722, 167722);
		backgroundImage.setImagePath("widgets/viewitem");	
		welcomeUsernameLabel->setup(this, true);
		welcomeUsernameLabel->setMaximumSize(167722, 130);

		gridLayout->addItem(welcomeUsernameLabel);
		tabWidget->addTab("Welcometo KDE 4.2", createWelcomeTab());
		tabWidget->addTab("Tip Browser", createTipBrowserTab());
		tabWidget->addTab("Links", createLinksTab());
		tabWidget->hide();

		welcomeUsernameLabel->setLabelText("<html><body><center><body><a href=\"http://www.kde.org\"><img src=\"<%icon>/48x48/apps/kde.png\" ALIGN=\"middle\"></a><p style='margin-top:5px; margin-bottom:0px; margin-left:0px; margin-right:0px; -qt-block-indent:0; text-indent:0px; font-size:16pt;'>Welcome <b><%username></b>to KDE 4.2</center></p></body></html>");
		_top->graphics_widget->setLayout(gridLayout);
		int index = top->config().readEntry("Default Tab",  0);
		tabWidget->setCurrentIndex(index);
		tabChanged(index);

		this->show();
		gridLayout->invalidate();
		gridLayout->activate();
		gridLayout->setSpacing(0);

	}
	void Ui_WelcomePlasmoid::setupUi(Plasma::PopupApplet&applet) {

	}
	QString Ui_WelcomePlasmoid::translate(QString& in) {
		
		return ""; // for now..
	}
	void Ui_WelcomePlasmoid::createTopFrame() {

	}
	void Ui_WelcomePlasmoid::invalidateLayouts() {
		
	}
	void Ui_WelcomePlasmoid::retranslate_ui(Plasma::PopupApplet&) {

	}
	void Ui_WelcomePlasmoid::retranslateUi(Plasma::PopupApplet&) {

	}
	void Ui_WelcomePlasmoid::setCurrentUrl(QString in) {
		this->setBrowserCurrentUrl(in);
	}
	void Ui_WelcomePlasmoid::addBookmark(QString&title, QString& url) {
		this->addLinkBookmark(title, url);
	}
	void Ui_WelcomePlasmoid::resizeEvent(QGraphicsSceneResizeEvent *e) {
		QGraphicsWidget::resizeEvent(e);
		gridLayout->invalidate();
	}
        void Ui_WelcomePlasmoid::tabChanged(int index) {
		Welcome_mainTabChanged(index);
		Browser_mainTabChanged(index);
		Links_mainTabChanged(index);
        }

	Plasma::IconWidget *Ui_WelcomePlasmoid::addTool(QString iconstring, QGraphicsLinearLayout &layout){
		Plasma::IconWidget *icon = addToolNoLayout(iconstring);
		layout.addItem(icon);
		return icon;
	}
	Plasma::IconWidget *Ui_WelcomePlasmoid::addToolNoLayout(QString iconstring){
		Plasma::IconWidget *icon = new Plasma::IconWidget(this);
		QAction *action = new QAction(KIcon(iconstring), QString(), top);
		icon->setAction(action);
		icon->setPreferredSize(icon->sizeFromIconSize(IconSize(KIconLoader::Toolbar)));
		return icon;
	}	
}
#include "../includes/Ui_Dialog.moc"
#endif
