/*
# * Copyright(c) 2008 Matthew Adams <roguestar191 at comcast.net>
# *
# * This program is free software; you can redistribute it and/or
# * modify it under the terms of the GNU General Public License as
# * published by the Free Software Foundation; either version 2 of
# * the License, or(at your option) any later version.
# *
# * This program is distributed in the hope that it will be useful,
# * but WITHOUT ANY WARRANTY; without even the implied warranty of
# * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
# * GNU General Public License for more details.
# *
# * You should have received a copy of the GNU General Public License
# * along with this program.  If not, see <http//www.gnu.org/licenses/>.
# */
#ifndef UI_LINKS_TAB_CPP
#define UI_LINKS_TAB_CPP

#include "../includes/Ui_LinksTab.h"
#include "../includes/Ui_Dialog.h"
#include <KBookmarkManager>
#include <QGraphicsSceneMouseEvent>
#include <QStandardItemModel>
#include "../includes/bookmarkitem.h"
#include "../includes/bookmarksdelegate.h"
#include "../welcome.h"
namespace welcome_plasmoid {
        class LinksTabPrivate : public QObject {
                Q_OBJECT
		friend class LinksTab;
                Ui_WelcomePlasmoid *top;
		LinksTab  *links;
		QGraphicsWidget *topFrame;
		QGraphicsGridLayout *blankLayout;
		QGraphicsWidget *blankWidget;

		GloweyIcon *aboutLabel;
		GloweyIcon *docuLabel;
		GloweyIcon *forumsLabel;
		GloweyIcon *mailingListLabel;
		QGraphicsWidget* spacer1;
		QGraphicsWidget* spacer2;
		ScrollableListWidget* bookmarksList;
		Plasma::TreeView *bookmarksView;
		BookmarksDelegate *m_bookmarksDelegate;
		public:
		QGraphicsGridLayout *myLayout;
		KBookmarkManager *bookmarkManager;
		QStandardItemModel *m_bookmarkModel;
                LinksTabPrivate(Ui_WelcomePlasmoid *t, LinksTab *l) : top(t), links(l), myLayout(), bookmarkManager(KBookmarkManager::userBookmarksManager()), m_bookmarkModel(0) {
			blankWidget = new QGraphicsWidget();
//			blankWidget->setMinimum(0);
//			blankWidget->setMaximum(100);
//			blankWidget->setValue(100);
//			blankWidget->setMeterType(Plasma::Meter::BarMeterHorizontal);

			blankLayout = new QGraphicsGridLayout();
			blankLayout->addItem(blankWidget,0,0);
//			blankWidget->setSizePolicy(QSizePolicy::Preferred, QSizePolicy::Preferred);
			blankLayout->invalidate();
			blankLayout->activate();
			


		};
                ~LinksTabPrivate() {delete bookmarkManager;};
                void setupUi() {
			topFrame = new QGraphicsWidget();

			topFrame->setSizePolicy(QSizePolicy::Expanding, QSizePolicy::Expanding);
			topFrame->hide();
			myLayout = new QGraphicsGridLayout(topFrame);

			topFrame->hide();
			aboutLabel = new GloweyIcon(top);
			docuLabel = new GloweyIcon(top);
			forumsLabel = new GloweyIcon(top);
			mailingListLabel = new GloweyIcon(top);

			spacer1 = new QGraphicsWidget();

//			bookmarksList = new ScrollableListWidget(NULL);
			bookmarksView = new Plasma::TreeView(top);

			bookmarksModelInit();
			bookmarksView->setModel(m_bookmarkModel);
			bookmarksView->nativeWidget()->setHeaderHidden(true);

			m_bookmarksDelegate = new BookmarksDelegate(this);
			bookmarksView->nativeWidget()->setItemDelegate(m_bookmarksDelegate);
			connect(m_bookmarksDelegate, SIGNAL(destroyBookmark(const QModelIndex &)), this, SLOT(removeBookmark(const QModelIndex &)));
			QGraphicsWidget *linksLayoutWidget = new QGraphicsWidget();
			QGraphicsGridLayout *linkslayout = new QGraphicsGridLayout(linksLayoutWidget);

			linkslayout->addItem(forumsLabel, 0,0);
			linkslayout->addItem(mailingListLabel,0,1);
			linkslayout->addItem(docuLabel,1,0);
			linkslayout->addItem(aboutLabel,1,1);
			linkslayout->addItem(spacer1,2,0);

			QGraphicsWidget *bookWidget = new QGraphicsWidget();
			QGraphicsLinearLayout *bookLayout = new QGraphicsLinearLayout(bookWidget);
			bookLayout->addItem(bookmarksView);

			myLayout->addItem(linksLayoutWidget, 0,0);
			myLayout->addItem(bookWidget,0,1);

			myLayout->activate();
			linkslayout->activate();
			bookLayout->activate();

			connect(bookmarkManager, SIGNAL(changed(const QString, const QString)), this, SLOT(bookmarksModelInit()));
			connect(bookmarksView->nativeWidget(), SIGNAL(clicked(const QModelIndex &)), this, SLOT(bookmarkClicked(const QModelIndex &)));
						
			aboutLabel->setIcon("feed-subscribe");
			docuLabel->setIcon("help-browser");
			forumsLabel->setIcon("kjournal");
			mailingListLabel->setIcon("email");
			aboutLabel->setText("About this program");
			docuLabel->setText("Some useful documetation");
			forumsLabel->setText("Forums");
			mailingListLabel->setText("Mailing lists");
			aboutLabel->setLink("file:<%file>/about.html");
			docuLabel->setLink("file:<%file>/documentation.html");
			forumsLabel->setLink("http://forum.kde.org");
			mailingListLabel->setLink("http://www.kde.org/mailinglists");	

//			aboutLabel->setLabelText("<!DOCTYPE HTML PUBLIC \"-//W3C//DTD HTML 4.0//EN\" \"http://www.w3.org/TR/REC-html40/strict.dtd\">\n <html><head><meta name=\"qrichtext\" content=\"1\" /><style type=\"text/css\">\np, li { white-space: pre-wrap; }\n</style></head><center><body style=\" font-family:'DejaVu Sans'; font-size:9pt; font-weight:400; font-style:normal;\">\n<p style=\" margin-top:0px; margin-bottom:0px; margin-left:0px; margin-right:0px; -qt-block-indent:0; text-indent:0px;\"><a href=\"file:<%file>/about.html\"><img src='<%icon>/48x48/actions/feed-subscribe.png'><br>About this program</center></a></p></body></html>");

//			docuLabel->setLabelText("<!DOCTYPE HTML PUBLIC \"-//W3C//DTD HTML 4.0//EN\" \"http://www.w3.org/TR/REC-html40/strict.dtd\">\n<html><head><meta name=\"qrichtext\" content=\"1\" /><style type=\"text/css\">\np, li { white-space: pre-wrap; }\n</style></head><body style=\" font-family:'DejaVu Sans'; font-size:9pt; font-weight:400; font-style:normal;\">\n<p align=\"center\" style=\" margin-top:0px; margin-bottom:0px; margin-left:0px; margin-right:0px; -qt-block-indent:0; text-indent:0px;\"><a href=\"file:<%file>/documentation.html\"><img src=\"<%icon>/48x48/apps/help-browser.png\"><br>Some Useful Documentation</a></p></body></html>"); 

//			forumsLabel->setLabelText("<!DOCTYPE HTML PUBLIC \"-//W3C//DTD HTML 4.0//EN\" \"http://www.w3.org/TR/REC-html40/strict.dtd\">\n<html><head><meta name=\"qrichtext\" content=\"1\" /><style type=\"text/css\">\np, li { white-space: pre-wrap; }\n</style></head><body style=\" font-family:'DejaVu Sans'; font-size:9pt; font-weight:400; font-style:normal;\">\n<p align=\"center\" style=\" margin-top:0px; margin-bottom:0px; margin-left:0px; margin-right:0px; -qt-block-indent:0; text-indent:0px;\"><a href=\"http://forum.kde.org/\"><img src=\"<%icon>/48x48/apps/kjournal.png\"><br>Forums</a></p></body></html>");

//			mailingListLabel->setLabelText("<!DOCTYPE HTML PUBLIC \"-//W3C//DTD HTML 4.0//EN\" \"http://www.w3.org/TR/REC-html40/strict.dtd\">\n<html><head><meta name=\"qrichtext\" content=\"1\" /><style type=\"text/css\">\np, li { white-space: pre-wrap; }\n</style></head><body style=\" font-family:'DejaVu Sans'; font-size:9pt; font-weight:400; font-style:normal;\">\n<p align=\"center\" style=\" margin-top:0px; margin-bottom:0px; margin-left:0px; margin-right:0px; -qt-block-indent:0; text-indent:0px;\"><a href=\"http://www.kde.org/mailinglists/\"><img src=\"<%icon>/48x48/apps/email.png\" /></a><a href=\"http://www.kde.org/mailinglists/\"><br />Mailing Lists</a></p></body></html>");

                }
                void invalidateLayouts() {

                }

		void fillGroup(BookmarkItem *parentItem, const KBookmarkGroup &group)
		{
			KBookmark it = group.first();

			while (!it.isNull()) {
				BookmarkItem *bookmarkItem = new BookmarkItem(it);
				bookmarkItem->setEditable(false);

				if (it.isGroup()) {
					KBookmarkGroup grp = it.toGroup();
					fillGroup( bookmarkItem, grp );
				}

				if (parentItem) {
					parentItem->appendRow(bookmarkItem);
				} else {
					m_bookmarkModel->appendRow(bookmarkItem);
				}	

				it = bookmarkManager->root().next(it);
			}
		}
		public slots:
		void mainTabChanged(int index) {
			KConfigGroup cg = top->top->config();
			static bool self = false;
			if(self == true) return;
			self = true;
			if(index == 2) {
				if( !cg.readEntry("Use Tab On Links", true) ) { 
					if(top->tabWidget->isVisible() ) {
						top->gridLayout->removeItem(top->tabWidget); 
						top->tabWidget->hide();
						top->gridLayout->invalidate();
					}	
				}
				if(!topFrame->isVisible())  {
					topFrame->show();
					top->gridLayout->addItem(topFrame);
					myLayout->invalidate();
					myLayout->activate();
				}
			} else {
				if(topFrame->isVisible() ) {
					topFrame->hide();
					top->gridLayout->removeItem(topFrame);
				}
			}
			top->top->graphicsWidget()->update();
			top->tabChanged(index);
			top->gridLayout->invalidate();
			top->gridLayout->activate();
			self = false;
		}
		void bookmarkClicked(const QModelIndex &index)
		{
			QStandardItem *item = m_bookmarkModel->itemFromIndex(index);
			if (item) {
				KUrl url(item->data(BookmarkItem::UrlRole).value<QString>());
				if (url.isValid()) {
					top->setCurrentUrl(url.prettyUrl());
				}
			}
		}
		void addBookmark(QString &title, QString& url) {
			KBookmark bookmark = bookmarkManager->root().addBookmark(title, url);
			bookmarkManager->save();
			BookmarkItem *bookmarkItem = new BookmarkItem(bookmark);
			m_bookmarkModel->appendRow(bookmarkItem);
		}
		void removeBookmark(const QModelIndex &index)
		{
			BookmarkItem *item = dynamic_cast<BookmarkItem *>(m_bookmarkModel->itemFromIndex(index));

			if (item) {
				KBookmark bookmark = item->bookmark();

				const QString text(i18nc("@info", "Do you really want to remove the bookmark to %1?", bookmark.url().host()));
				const bool del = KMessageBox::warningContinueCancel(0,
                                                            text,
                                                            QString(),
                                                            KGuiItem(i18nc("@action:button", "Delete Bookmark"))
                                                            ) == KMessageBox::Continue;

				if (!del) {
					return;
				}

				bookmark.parentGroup().deleteBookmark(bookmark);
				bookmarkManager->save();
			}

			if (item && item->parent()) {
				item->parent()->removeRow(index.row());
			} else {
				m_bookmarkModel->removeRow(index.row());
			}

		}

//		void removeBookmark()
//		{
//			QModelIndexList list = m_bookmarkModel->match(m_bookmarkModel->index(0,0), BookmarkItem::UrlRole, m_url.prettyUrl());
//			if (!list.isEmpty()) {
//				removeBookmark(list.first());
//			}
//		}
		void bookmarksModelInit()
		{
			if (m_bookmarkModel) {
				m_bookmarkModel->clear();
			} else {
				m_bookmarkModel = new QStandardItemModel;
			}
			fillGroup(0, bookmarkManager->root());
		}
        };
        LinksTab::LinksTab(Ui_WelcomePlasmoid *t) : Dialog_Tools() {
                priv = new LinksTabPrivate(t, this);
        }
        LinksTab::~LinksTab() {
                delete (LinksTabPrivate*)(priv);
        }
	QGraphicsGridLayout* LinksTab::createLinksTab() {
		((LinksTabPrivate*)(priv))->setupUi();
		return ((LinksTabPrivate*)(priv))->blankLayout;
	}
	void LinksTab::invalidateLayouts() {
		((LinksTabPrivate*)(priv))->invalidateLayouts();
	}
	void LinksTab::retranslateUi() {

	}
	void LinksTab::addLinkBookmark(QString &title, QString &url) {
		((LinksTabPrivate*)(priv))->addBookmark(title, url);
	}
	void LinksTab::Links_mainTabChanged(int index) {
		((LinksTabPrivate*)(priv))->mainTabChanged(index);
	}
	QGraphicsWidget* LinksTab::getLinksTab() {
		return ((LinksTabPrivate*)(priv))->topFrame;
	}
}
#include "../includes/Ui_LinksTab.moc"
#endif
