/*
*   Copyright 2007 by Aaron Seigo <aseigo@kde.org>
*   Copyright 2008 by Chani Armitage <chanika@gmail.com>
*
*   This program is free software; you can redistribute it and/or modify
*   it under the terms of the GNU Library General Public License version 2,
*   or (at your option) any later version.
*
*   This program is distributed in the hope that it will be useful,
*   but WITHOUT ANY WARRANTY; without even the implied warranty of
*   MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
*   GNU General Public License for more details
*
*   You should have received a copy of the GNU Library General Public
*   License along with this program; if not, write to the
*   Free Software Foundation, Inc.,
*   51 Franklin Street, Fifth Floor, Boston, MA  02110-1301, USA.
*/

#ifndef PLASMA_BLANKDESKTOP_H
#define PLASMA_BLANKDESKTOP_H

#include <QList>
#include <QObject>
#include <QStyleOptionGraphicsItem>

#include <plasma/containment.h>
#include <plasma/animator.h>
//#include <plasma/widgets/widget.h>

class QAction;

/**
 * Blank Desktop
 *
 * This containment is a minimal, blank desktop. it has the regular things provided by Containment
 * (toolbox, applethandles), a contextmenu, and a backgroundcolour taken from the plasma theme.
 * there is no configuration. period. there shouldn't be anything to configure here.
 */

class BlankDesktop : public Plasma::Containment
{
    Q_OBJECT

public:
    BlankDesktop(QObject *parent, const QVariantList &args);
    ~BlankDesktop();
    void init();

    QList<QAction*> contextualActions();

protected Q_SLOTS:
    void runCommand();
    void lockScreen();
    void logout();

private:
    QAction *m_lockDesktopAction;
    QAction *m_appletBrowserAction;
    QAction *m_runCommandAction;
    QAction *m_lockScreenAction;
    QAction *m_logoutAction;
    QAction *m_separator;
    QAction *m_zoomInAction;
    QAction *m_zoomOutAction;
};

#endif
