/***************************************************************************
 *                                                                         *
 *   This program is free software; you can redistribute it and/or modify  *
 *   it under the terms of the GNU General Public License as published by  *
 *   the Free Software Foundation; either version 2 of the License, or     *
 *   (at your option) any later version.                                   *
 *                                                                         *
 *   Copyright (C) 2008 by Dennis Nienhüser <earthwings@gentoo.org>        *
 *                                                                         *
 *   This program is distributed in the hope that it will be useful,       *
 *   but WITHOUT ANY WARRANTY; without even the implied warranty of        *
 *   MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the         *
 *   GNU General Public License for more details.                          *
 *                                                                         *
 *   You should have received a copy of the GNU General Public License     *
 *   along with this program; if not, write to the                         *
 *   Free Software Foundation, Inc.,                                       *
 *   51 Franklin Street, Fifth Floor, Boston, MA  02110-1301  USA .        *
 ***************************************************************************/

#include "kabccontact.h"

KABCContact::KABCContact(const KABC::Addressee &contact) :
	Contact(contact.uid()), m_contact(contact)
{
}

QString KABCContact::displayName()
{
	return m_contact.formattedName();
}

QString KABCContact::photo()
{
	return m_contact.photo().url();
}

QString KABCContact::email()
{
	if (m_contact.emails().size() > 0)
	{
		return m_contact.emails().at(0);
	}

	return QString();
}

bool KABCContact::hasLocation()
{
	return m_contact.geo().isValid();
}

QPointF KABCContact::location()
{
	return QPointF(m_contact.geo().longitude(), m_contact.geo().latitude());
}

QDateTime KABCContact::birthday()
{
    return m_contact.birthday();    
}
