/***************************************************************************
 *                                                                         *
 *   This program is free software; you can redistribute it and/or modify  *
 *   it under the terms of the GNU General Public License as published by  *
 *   the Free Software Foundation; either version 2 of the License, or     *
 *   (at your option) any later version.                                   *
 *                                                                         *
 *   Copyright (C) 2008 by Dennis Nienhüser <earthwings@gentoo.org>        *
 *                                                                         *
 *   This program is distributed in the hope that it will be useful,       *
 *   but WITHOUT ANY WARRANTY; without even the implied warranty of        *
 *   MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the         *
 *   GNU General Public License for more details.                          *
 *                                                                         *
 *   You should have received a copy of the GNU General Public License     *
 *   along with this program; if not, write to the                         *
 *   Free Software Foundation, Inc.,                                       *
 *   51 Franklin Street, Fifth Floor, Boston, MA  02110-1301  USA .        *
 ***************************************************************************/

#ifndef KABC_SOURCE_H
#define KABC_SOURCE_H

#include "contactsource.h"

#include <QtCore/QObject>
#include <QtCore/QMap>
#include <QtCore/QString>

/**
 * Manages KABC::Addressbook::StdAddressbook contacts. Fetches their data and
 * announces contact additions and removals.
 */
class KABCSource: public ContactSource
{
Q_OBJECT

public:
	/**
	 * Reimplemented from ContactSource. Get the contact list from kaddressbook.
	 */
	virtual void initialize()		;

private	Q_SLOTS:
	/**
	 * Called when the addressbook changes, checks that cached contacts are valid
	 *  and announces new ones
	 */
	void update();

private:
	/** Current contact list */
	QMap<QString,Contact::Ptr> m_contacts;
};

#endif // KABC_SOURCE_H
