/*
 * Copyright (C) 2010 Eduardo Robles Elvira <edulix@gmail.com>
 *
 * This library is free software; you can redistribute it and/or
 * modify it under the terms of the GNU Library General Public
 * License as published by the Free Software Foundation; either
 * version 2 of the License, or (at your option) any later version.
 *
 * This library is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE. See the GNU
 * Library General Public License for more details.
 *
 * You should have received a copy of the GNU Library General Public License
 * along with this library; see the file COPYING.LIB. If not, write to
 * the Free Software Foundation, Inc., 51 Franklin Street, Fifth Floor,
 * Boston, MA 02110-1301, USA.
 */
#ifndef GLOBALSHORTCUTS_RUNNER_H
#define GLOBALSHORTCUTS_RUNNER_H

#include <plasma/abstractrunner.h>
#include <KIcon>

// Define our plasma Runner
class GlobalShortcutsRunner : public Plasma::AbstractRunner
{
    Q_OBJECT

public:
    // Basic Create/Destroy
    GlobalShortcutsRunner(QObject *parent, const QVariantList& args);
    ~GlobalShortcutsRunner();

    void match(Plasma::RunnerContext &context);
    void run(const Plasma::RunnerContext &context, const Plasma::QueryMatch &match);

protected Q_SLOTS:
    void init();

private:
    class Private;
    Private *const d;
};
// This is the command that links the applet to the .desktop file
K_EXPORT_PLASMA_RUNNER(globalshortcuts_runner, GlobalShortcutsRunner)

#endif
