/*
 *   Copyright (C) 2008 Petri Damsten <damu@iki.fi>
 *
 *   This program is free software; you can redistribute it and/or modify
 *   it under the terms of the GNU Library General Public License as
 *   published by the Free Software Foundation; either version 2, or
 *   (at your option) any later version.
 *
 *   This program is distributed in the hope that it will be useful,
 *   but WITHOUT ANY WARRANTY; without even the implied warranty of
 *   MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 *   GNU General Public License for more details
 *
 *   You should have received a copy of the GNU Library General Public
 *   License along with this program; if not, write to the
 *   Free Software Foundation, Inc.,
 *   51 Franklin Street, Fifth Floor, Boston, MA  02110-1301, USA.
 */

#include <plasma/runnercontext.h>
#include <plasma/querymatch.h>
#include <plasma/abstractrunner.h>
#include "searchcontextscript.h"
#include "searchmatchscript.h"
#include <KDebug>

SearchContextScript::SearchContextScript(Plasma::AbstractRunner *runner,
                                         Plasma::RunnerContext& searchContext)
    : m_runner(runner), m_searchContext(searchContext)
{
}

SearchContextScript::~SearchContextScript()
{
}

QString SearchContextScript::query()
{
    return m_searchContext.query();
}

bool SearchContextScript::addMatch(const QString &term, QObject *match)
{
    SearchMatchScript *m = qobject_cast<SearchMatchScript*>(match);
    Plasma::QueryMatch& queryMatch = m->match();
    //delete m; ?
    return m_searchContext.addMatch(term, queryMatch);
}

#include "searchcontextscript.moc"
