/***************************************************************************
 *   Copyright (C) 2009 by Wang Hoi <zealot.hoi@gmail.com>                 *
 *                                                                         *
 *   This program is free software; you can redistribute it and/or modify  *
 *   it under the terms of the GNU General Public License as published by  *
 *   the Free Software Foundation; either version 2 of the License, or     *
 *   (at your option) any later version.                                   *
 *                                                                         *
 *   This program is distributed in the hope that it will be useful,       *
 *   but WITHOUT ANY WARRANTY; without even the implied warranty of        *
 *   MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the         *
 *   GNU General Public License for more details.                          *
 *                                                                         *
 *   You should have received a copy of the GNU General Public License     *
 *   along with this program; if not, write to the                         *
 *   Free Software Foundation, Inc.,                                       *
 *   51 Franklin Street, Fifth Floor, Boston, MA  02110-1301  USA .        *
 ***************************************************************************/

#ifndef KORATMINIBAR_H
#define KORATMINIBAR_H

#include "koratbar_export.h"

#include "koratitem.h"
#include "koratbutton.h"

#include <QGraphicsSceneResizeEvent>

namespace Korat
{
class MiniBarPrivate;
class KORATBAR_EXPORT MiniBar : public Item
{
    Q_OBJECT
public:
    MiniBar(QGraphicsItem *parent=0);
    virtual ~MiniBar();

    virtual bool isContainer();

    virtual QList<WeightList> availableWidths();
    virtual qreal getWidth(const WeightList &);
    virtual void adjustWidth(const WeightList &);

    void addItem(Item *item);
    void removeItem(int index);
    void removeItem(Item *item);
    Item *getItem(int index);

Q_SIGNALS:
    void sizeChanged();

protected:

    virtual void resizeEvent(QGraphicsSceneResizeEvent * event);

    /**
     * Reimplemented from QGraphicsWidget
     */
    virtual void paint(QPainter *painter,
                       const QStyleOptionGraphicsItem *option,
                       QWidget *widget = 0);
private:
    MiniBarPrivate *d;
};

}

#endif // KORATMINIBAR_H
