#ifndef WINDOW_H
#define WINDOW_H

#include "ui_window.h"


class Widget;
class PropertyEditor;
class QTreeWidget;
class QTreeWidgetItem;
class QPushButton;

namespace Quasar {
    class Node;
    class Composition;
}

class Window : public QMainWindow
{
    Q_OBJECT
public:
    Window();

private:
    void setupDockWidgets();
    void setupFilters();

    Quasar::Composition *createComposition(const QString &filter);

private slots:
    void itemActivated(QTreeWidgetItem *item, int column);
    void selectFile();

private:
    Ui_MainWindow ui;

    Widget         *m_widget;
    PropertyEditor *m_editor;
    QTreeWidget    *m_treeWidget;
    QPushButton    *m_fileButton;

    QString m_location;
    Quasar::Composition *m_compo;
    Quasar::Node        *m_inputNode;
    Quasar::Node        *m_filterNode;
    Quasar::Node        *m_outputNode;
};

#endif
