#ifndef SHADER_TYPES_H
#define SHADER_TYPES_H

struct vec2
{
    vec2()
        : x(0),
          y(0)
    {}
    explicit vec2(float x)
        : x(x),
          y(x)
    {}
    float x, y;
};

struct vec3
{
    vec3()
        : x(0), y(0), z(0)
    {}
    explicit vec3(const vec2 &val)
        : x(val.x),
          y(val.y),
          z(0)
    {}
    explicit vec3(float val)
        : x(val),
          y(val),
          z(val)
    {}
    float x, y, z;
};

struct vec4
{
    vec4()
        : x(0), y(0), z(0), w(0)
    {}
    explicit vec4(const vec2 &val)
        : x(val.x),
          y(val.y),
          z(0),
          w(0)
    {}
    explicit vec4(const vec3 &val)
        : x(val.x),
          y(val.y),
          z(val.z),
          w(0)
    {}
    explicit vec4(float val)
        : x(val),
          y(val),
          z(val),
          w(val)
    {}
    float x, y, z, w;
};

#endif
