#ifndef QUASAR_CONVOLUTIONNODE_P_H
#define QUASAR_CONVOLUTIONNODE_P_H

#include "filternode.h"
#include <GL/gl.h>

class QColor;

namespace Quasar
{
    class ConvolutionNode : public FilterNode
    {
        Q_OBJECT
    public:
        ConvolutionNode(const QString &name);

        virtual QRectF domainOfDefinition(const QRectF &rect) const;
        virtual QRectF regionOfInterest(const QRectF &rect) const;

        virtual void aboutToExecute();
    protected:
        void programChanged(GLuint prog);
        virtual void fillConvolution(GLint *convolution,
                                     GLfloat *scale,
                                     QColor *baseColor) = 0;
        void setupConvolution();
        void setupOffsets(const Texture &tex);

    protected:
        const GLuint m_kernelSize;
    };
}


#endif
