#ifndef QUASAR_IMAGEINPUT_P_H
#define QUASAR_IMAGEINPUT_P_H

#include "graphicsnode.h"

#include "texture.h"

namespace Quasar
{
    class ImageInputNode : public GraphicsNode
    {
        Q_OBJECT
    public:
        ImageInputNode();

        virtual QRectF domainOfDefinition(const QRectF &rect) const;
        virtual QRectF regionOfInterest(const QRectF &rect) const;

    protected:
        virtual bool execute();
        virtual void prepare();
        virtual void propertyChanged(const QString &name,
                                     const QVariant &val);
    private:
        Texture m_texture;
        QImage  m_image;
    };
}

#endif
